



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Developing a Custom Membership Provider from the scratch, and using it in the FBA (Form Based Authentication) in SharePoint 2010</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Developing a Custom Membership Provider from the scratch, and using it in the FBA (Form Based Authentication) in SharePoint 2010</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 16:59:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>//http://blog.sharedove.com/adisjugo/index.php/2011/01/05/writing-a-custom-membership-provider-and-using-it-for-fba-forms-based-authentication-in-sharepoint-2010-from-the-scratch/</p>
<p>Developing a Custom Membership Provider from the scratch, and using it in the FBA (Form Based Authentication) in SharePoint 2010<br />A</p>
<p>SharePoint 2010 brought us the whole new authentication world &ndash; Claims-Based authentication, based on the Windows Identity Foundation. To go through the whole claims-based logic would take too much time and space on this blog, but it&rsquo;s nevertheless crucial for understanding the whole concept. If you haven&rsquo;t already seen it, please take a look at a great interview with Microsoft&rsquo;s Venky Veeraraghavan, one of the people who have designed the whole concept.</p>
<p>What I will focus on now is how to use the claims-based authentication to set up a combined, Windows Authentication and Forms Based Authentication (FBA) on a SharePoint Web Application. It&rsquo;s a fairly common scenario &ndash; you have your internal people, who are members of the domain, and external partners or salesmen who have to use resources in your intranet, but they are not members of your domain.</p>
<p>internalexternal<br />Past times<br />Way back, in the times of MOSS 2007, there was a Form Based Authentication. There was even a way to combine it with Windows Authentication. But it was not an easy thing to do. And, even once it was done, it was always a funny thing to observe an user who has just authenticated over FBA trying to open a Word document. After clicking three times on the &ldquo;Cancel&rdquo; button in the great Windows authentication popup, the document opens anyways. Sometimes.</p>
<p>Now, try to explain that to the customer&hellip;</p>
<p>It ended up with administrators creating domain accounts for external people just because of the SharePoint. Man, the loved it.</p>
<p>But, as we have said earlier, everything is claims and good now. Except if you chose the classical authentication mode when you are creating your SharePoint web application, which is the default setting. But let&rsquo;s not get into it&hellip;</p>
<p>Anyway, it works now. You do have to change some defaults, you do need some afterwards (no, Microsoft still doesn&rsquo;t want us to give up on the SharePoint-Voodoo), but &ndash; it works.</p>
<p>Back to the future<br />Let&rsquo;s think of the following scenario. We are a rock label. Our employees have the following usernames: bspringsteen, jcocker, bvox, mjagger and smacgowan. We make a great business, earn lot of money, and we have decided to support some poor jazz guys. We have an old web application, maybe even PHP with MySQL database, which is used by those external jazz people. It means, they already have usernames and passwords there. Now, we want to give them the access to our brand new SharePoint portal, but we don&rsquo;t want them in the AD. They are not the rock&rsquo;n&rsquo;roll people, after all. We want to use existing authentication (usernames and passwords for the old PHP application), and just to give them necessary rights on our SharePoint portal.</p>
<p>Building a custom ASP.NET membership and roles provider<br />The first thing we have to do is to write a custom ASP.NET membership provider. It&rsquo;s peace of code which will tell us who can authenticate, and who can&rsquo;t. That&rsquo;s nothing new, but it has to be done.</p>
<p>1. Create a new .NET 3.5 class library in VS 2010</p>
<p>2. Create two new classes in the class library, one has to inherit from the MembersipProvider class, and the other from the RolesProvider class (both in System.Web.Security):</p>
<p>image</p>
<p>Now, let&rsquo;s take a look at the &ldquo;ShareDoveMembershipProvider&rdquo; class. You have to implement the following methods:</p>
<p>public override MembershipUserCollection GetAllUsers(int pageIndex, int pageSize, out int totalRecords)</p>
<p>public override MembershipUserCollection FindUsersByEmail(string emailToMatch, int pageIndex, int pageSize, out int totalRecords)</p>
<p>public override MembershipUserCollection FindUsersByName(string usernameToMatch, int pageIndex, int pageSize, out int totalRecords)</p>
<p>public override MembershipUser GetUser(string username, bool userIsOnline)</p>
<p>public override MembershipUser GetUser(object providerUserKey, bool userIsOnline)</p>
<p>public override string GetUserNameByEmail(string email)</p>
<p>public override bool ValidateUser(string username, string password)<br />You see, this is the place where you implement all your user-authentication logic. Let&rsquo;s keep the things simple for the demo purposes, and let&rsquo;s hard code our Jazz-people as users in this class.</p>
<p>In the real life you would of course talk to the MySql database mentioned in the example above which contains usernames and passwords, or to the web service, or to a sharepoint-voodoo-priest or whatever. Right now, as we said, just a hard coded example:</p>
<p>1: using System;</p>
<p>2: using System.Collections.Generic;</p>
<p>3: using System.Linq;</p>
<p>4: using System.Text;</p>
<p>5: using System.Web.Security;</p>
<p>6: using System.Collections.Specialized;</p>
<p>7:</p>
<p>8: namespace Progressive.ShareDove.DiverseTests.ShareDoveMembershipAndRolesProvider</p>
<p>9: {</p>
<p>10:     /// &lt;summary&gt;</p>
<p>11:     /// Custom ShareDove Membership Provider</p>
<p>12:     /// &lt;/summary&gt;</p>
<p>13:     public class ShareDoveMembershipProvider : MembershipProvider</p>
<p>14:     {</p>
<p>15:</p>
<p>16:         /// &lt;summary&gt;</p>
<p>17:         /// List of all membership users</p>
<p>18:         /// &lt;/summary&gt;</p>
<p>19:         private MembershipUserCollection m_AllUsers;</p>
<p>20:</p>
<p>21:</p>
<p>22:         /// &lt;summary&gt;</p>
<p>23:         /// /// &lt;summary&gt;</p>
<p>24:         /// Generate Some dummy users for demo purposes :)</p>
<p>25:         /// &lt;/summary&gt;</p>
<p>26:         private void generateUsers()</p>
<p>27:         {</p>
<p>28:             m_AllUsers = new MembershipUserCollection();</p>
<p>29:</p>
<p>30:             //</p>
<p>31:             //in this part of code there should be some really impressive logic - like retrieving users from the external LOB system, or web service, or whatever</p>
<p>32:             //but let's in this example add just somt jazz legends here... :)</p>
<p>33:             m_AllUsers.Add(new MembershipUser(this.Name, "Ella Fitzgerald", "EllaFitzgerald", "Ella.Fitzgerald@sharedove.com", "How good is jazz?", "EF is good", true, false, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today));</p>
<p>34:             m_AllUsers.Add(new MembershipUser(this.Name, "Billie Holiday", "BillieHoliday", "Billie.Holiday@sharedove.com", "How good is jazz?", "BH is good", true, false, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today));</p>
<p>35:             m_AllUsers.Add(new MembershipUser(this.Name, "Louis Armstrong", "LouisArmstrong", "Louis.Armstrong@sharedove.com", "How good is jazz?", "LA is good", true, false, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today));</p>
<p>36:             m_AllUsers.Add(new MembershipUser(this.Name, "Duke Ellington", "DukeEllington", "Duke.Ellington@sharedove.com", "How good is jazz?", "DE is good", true, false, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today));</p>
<p>37:             m_AllUsers.Add(new MembershipUser(this.Name, "Miles Davis", "MilesDavis", "Miles.Davis@sharedove.com", "How good is jazz?", "MD is good", true, false, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today));</p>
<p>38:             m_AllUsers.Add(new MembershipUser(this.Name, "Fletcher Henderson", "FletcherHenderson", "Fletcher.Henderson@sharedove.com", "How good is jazz?", "FH is good", true, false, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today));</p>
<p>39:             m_AllUsers.Add(new MembershipUser(this.Name, "Benny Goodman", "BennyGoodman", "Benny.Goodman@sharedove.com", "How good is jazz?", "BG is good", true, false, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today));</p>
<p>40:             m_AllUsers.Add(new MembershipUser(this.Name, "Jelly Roll Morton", "JellyRollMorton", "Jelly.Roll.Morton@sharedove.com", "How good is jazz?", "JRM is good", true, false, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today, DateTime.Today));</p>
<p>41:</p>
<p>42:</p>
<p>43:         }</p>
<p>44:</p>
<p>45:         /// &lt;summary&gt;</p>
<p>46:         /// Retrieve all the users ShareDove Membership provider can authenticate.</p>
<p>47:         /// We will ignore the paging here, for demo purposes</p>
<p>48:         /// &lt;/summary&gt;</p>
<p>49:         /// &lt;param name="pageIndex"&gt;Index of the results page we are returning (ignored in this demo example)&lt;/param&gt;</p>
<p>50:         /// &lt;param name="pageSize"&gt;Number of the items returned in a results page  (ignored in this demo example)&lt;/param&gt;</p>
<p>51:         /// &lt;param name="totalRecords"&gt;Total number of records we are returning&lt;/param&gt;</p>
<p>52:         /// &lt;returns&gt;User Collection with all users&lt;/returns&gt;</p>
<p>53:         public override MembershipUserCollection GetAllUsers(int pageIndex, int pageSize, out int totalRecords)</p>
<p>54:         {</p>
<p>55:</p>
<p>56:             if (m_AllUsers == null) generateUsers();</p>
<p>57:</p>
<p>58:             totalRecords = m_AllUsers.Count;</p>
<p>59:             return m_AllUsers;</p>
<p>60:         }</p>
<p>61:</p>
<p>62:         /// &lt;summary&gt;</p>
<p>63:         /// Find users by email</p>
<p>64:         /// &lt;/summary&gt;</p>
<p>65:         /// &lt;param name="emailToMatch"&gt;Email sto search&lt;/param&gt;</p>
<p>66:         /// &lt;param name="pageIndex"&gt;Index of the results page we are returning (ignored in this demo example)&lt;/param&gt;</p>
<p>67:         /// &lt;param name="pageSize"&gt;Number of the items returned in a results page  (ignored in this demo example)&lt;/param&gt;</p>
<p>68:         /// &lt;param name="totalRecords"&gt;Total number of records we are returning&lt;/param&gt;</p>
<p>69:         /// &lt;returns&gt;Members found by email&lt;/returns&gt;</p>
<p>70:         public override MembershipUserCollection FindUsersByEmail(string emailToMatch, int pageIndex, int pageSize, out int totalRecords)</p>
<p>71:         {</p>
<p>72:</p>
<p>73:             if (m_AllUsers == null) generateUsers();</p>
<p>74:</p>
<p>75:</p>
<p>76:             MembershipUserCollection returnFoundUsers = new MembershipUserCollection();</p>
<p>77:</p>
<p>78:             (m_AllUsers.Cast&lt;MembershipUser&gt;().</p>
<p>79:                 Where(membershipUser =&gt; membershipUser.Email.ToLowerInvariant().Contains(emailToMatch.ToLowerInvariant())))</p>
<p>80:                 .ToList().ForEach(returnFoundUsers.Add);</p>
<p>81:</p>
<p>82:             totalRecords = returnFoundUsers.Count;</p>
<p>83:             return returnFoundUsers;</p>
<p>84:</p>
<p>85:         }</p>
<p>86:</p>
<p>87:         /// &lt;summary&gt;</p>
<p>88:         /// Find users by username</p>
<p>89:         /// &lt;/summary&gt;</p>
<p>90:         /// &lt;param name="emailToMatch"&gt;Email sto search&lt;/param&gt;</p>
<p>91:         /// &lt;param name="pageIndex"&gt;Index of the results page we are returning (ignored in this demo example)&lt;/param&gt;</p>
<p>92:         /// &lt;param name="pageSize"&gt;Number of the items returned in a results page  (ignored in this demo example)&lt;/param&gt;</p>
<p>93:         /// &lt;param name="totalRecords"&gt;Total number of records we are returning&lt;/param&gt;</p>
<p>94:         /// &lt;returns&gt;Members found by email&lt;/returns&gt;</p>
<p>95:         public override MembershipUserCollection FindUsersByName(string usernameToMatch, int pageIndex, int pageSize, out int totalRecords)</p>
<p>96:         {</p>
<p>97:             if (m_AllUsers == null) generateUsers();</p>
<p>98:</p>
<p>99:             MembershipUserCollection returnFoundUsers = new MembershipUserCollection();</p>
<p>100:</p>
<p>101:             (m_AllUsers.Cast&lt;MembershipUser&gt;().</p>
<p>102:                 Where(membershipUser =&gt; membershipUser.UserName.ToLowerInvariant().Contains(usernameToMatch.ToLowerInvariant())))</p>
<p>103:                 .ToList().ForEach(returnFoundUsers.Add);</p>
<p>104:</p>
<p>105:             totalRecords = returnFoundUsers.Count;</p>
<p>106:             return returnFoundUsers;</p>
<p>107:         }</p>
<p>108:</p>
<p>109:         /// &lt;summary&gt;</p>
<p>110:         /// Gets a specified user by it's username</p>
<p>111:         /// &lt;/summary&gt;</p>
<p>112:         /// &lt;param name="username"&gt;Username&lt;/param&gt;</p>
<p>113:         /// &lt;param name="userIsOnline"&gt;If true, updates the last-activity date/time stamp for the specified user.&lt;/param&gt;</p>
<p>114:         /// &lt;returns&gt;Found Membership user&lt;/returns&gt;</p>
<p>115:         public override MembershipUser GetUser(string username, bool userIsOnline)</p>
<p>116:         {</p>
<p>117:</p>
<p>118:             if (m_AllUsers == null) generateUsers();</p>
<p>119:</p>
<p>120:             IEnumerable&lt;MembershipUser&gt; usersFound = m_AllUsers.Cast&lt;MembershipUser&gt;().Where(membershipUser =&gt; membershipUser.UserName == username);</p>
<p>121:</p>
<p>122:             return usersFound.FirstOrDefault();</p>
<p>123:</p>
<p>124:         }</p>
<p>125:</p>
<p>126:</p>
<p>127:         /// &lt;summary&gt;</p>
<p>128:         /// Gets a specified user by it's Provider User Key</p>
<p>129:         /// &lt;/summary&gt;</p>
<p>130:         /// &lt;param name="username"&gt;Provider User Key&lt;/param&gt;</p>
<p>131:         /// &lt;param name="userIsOnline"&gt;If true, updates the last-activity date/time stamp for the specified user.&lt;/param&gt;</p>
<p>132:         /// &lt;returns&gt;Found Membership user&lt;/returns&gt;</p>
<p>133:         public override MembershipUser GetUser(object providerUserKey, bool userIsOnline)</p>
<p>134:         {</p>
<p>135:</p>
<p>136:             if (m_AllUsers == null) generateUsers();</p>
<p>137:</p>
<p>138:             IEnumerable&lt;MembershipUser&gt; usersFound = m_AllUsers.Cast&lt;MembershipUser&gt;().Where(membershipUser =&gt; membershipUser.ProviderUserKey.ToString() == providerUserKey.ToString());</p>
<p>139:</p>
<p>140:             return usersFound.FirstOrDefault();</p>
<p>141:         }</p>
<p>142:</p>
<p>143:</p>
<p>144:         /// &lt;summary&gt;</p>
<p>145:         /// Get's the username based on the member's email address</p>
<p>146:         /// &lt;/summary&gt;</p>
<p>147:         /// &lt;param name="email"&gt;member's email address&lt;/param&gt;</p>
<p>148:         /// &lt;returns&gt;Found username&lt;/returns&gt;</p>
<p>149:         public override string GetUserNameByEmail(string email)</p>
<p>150:         {</p>
<p>151:             if (m_AllUsers == null) generateUsers();</p>
<p>152:</p>
<p>153:             IEnumerable&lt;MembershipUser&gt; usersFound = m_AllUsers.Cast&lt;MembershipUser&gt;().Where(membershipUser =&gt; membershipUser.Email.ToLowerInvariant() == email.ToLowerInvariant());</p>
<p>154:</p>
<p>155:             MembershipUser user = usersFound.FirstOrDefault();</p>
<p>156:</p>
<p>157:             if (user != null)</p>
<p>158:                 return user.UserName;</p>
<p>159:             else</p>
<p>160:                 return null;</p>
<p>161:</p>
<p>162:         }</p>
<p>163:</p>
<p>164:</p>
<p>165:         /// &lt;summary&gt;</p>
<p>166:         /// A Dummy validation method - here we are only going to check if the username exists and if any password is given - it will be enough for the demo purposes</p>
<p>167:         /// &lt;/summary&gt;</p>
<p>168:         /// &lt;param name="username"&gt;username&lt;/param&gt;</p>
<p>169:         /// &lt;param name="password"&gt;password&lt;/param&gt;</p>
<p>170:         /// &lt;returns&gt;validation result&lt;/returns&gt;</p>
<p>171:         public override bool ValidateUser(string username, string password)</p>
<p>172:         {</p>
<p>173:             if (m_AllUsers == null) generateUsers();</p>
<p>174:</p>
<p>175:             IEnumerable&lt;MembershipUser&gt; usersFound = m_AllUsers.Cast&lt;MembershipUser&gt;().Where(membershipUser =&gt; membershipUser.UserName == username);</p>
<p>176:</p>
<p>177:             MembershipUser user = usersFound.FirstOrDefault();</p>
<p>178:</p>
<p>179:             if (user != null)</p>
<p>180:             {</p>
<p>181:                 if (string.IsNullOrEmpty(password))</p>
<p>182:                 {</p>
<p>183:                     return false;</p>
<p>184:                 }</p>
<p>185:                 else</p>
<p>186:                 {</p>
<p>187:                     return true;</p>
<p>188:                 }</p>
<p>189:             }</p>
<p>190:             else</p>
<p>191:                 return false;</p>
<p>192:</p>
<p>193:         }</p>
<p>194:</p>
<p>195:         #region Not implemented methods and properties</p>
<p>196:         public override string ApplicationName</p>
<p>197:         {</p>
<p>198:             get</p>
<p>199:             {</p>
<p>200:                 throw new NotImplementedException();</p>
<p>201:             }</p>
<p>202:             set</p>
<p>203:             {</p>
<p>204:                 throw new NotImplementedException();</p>
<p>205:             }</p>
<p>206:         }</p>
<p>207:</p>
<p>208:         public override bool ChangePassword(string username, string oldPassword, string newPassword)</p>
<p>209:         {</p>
<p>210:             throw new NotImplementedException();</p>
<p>211:         }</p>
<p>212:</p>
<p>213:         public override bool ChangePasswordQuestionAndAnswer(string username, string password, string newPasswordQuestion, string newPasswordAnswer)</p>
<p>214:         {</p>
<p>215:             throw new NotImplementedException();</p>
<p>216:         }</p>
<p>217:</p>
<p>218:         public override MembershipUser CreateUser(string username, string password, string email, string passwordQuestion, string passwordAnswer, bool isApproved, object providerUserKey, out MembershipCreateStatus status)</p>
<p>219:         {</p>
<p>220:             throw new NotImplementedException();</p>
<p>221:         }</p>
<p>222:</p>
<p>223:         public override bool DeleteUser(string username, bool deleteAllRelatedData)</p>
<p>224:         {</p>
<p>225:             throw new NotImplementedException();</p>
<p>226:         }</p>
<p>227:</p>
<p>228:         public override bool EnablePasswordReset</p>
<p>229:         {</p>
<p>230:             get { throw new NotImplementedException(); }</p>
<p>231:         }</p>
<p>232:</p>
<p>233:         public override bool EnablePasswordRetrieval</p>
<p>234:         {</p>
<p>235:             get { throw new NotImplementedException(); }</p>
<p>236:         }</p>
<p>237:</p>
<p>238:         public override int GetNumberOfUsersOnline()</p>
<p>239:         {</p>
<p>240:             throw new NotImplementedException();</p>
<p>241:         }</p>
<p>242:</p>
<p>243:         public override string GetPassword(string username, string answer)</p>
<p>244:         {</p>
<p>245:             throw new NotImplementedException();</p>
<p>246:         }</p>
<p>247:</p>
<p>248:         public override int MaxInvalidPasswordAttempts</p>
<p>249:         {</p>
<p>250:             get { throw new NotImplementedException(); }</p>
<p>251:         }</p>
<p>252:</p>
<p>253:         public override int MinRequiredNonAlphanumericCharacters</p>
<p>254:         {</p>
<p>255:             get { throw new NotImplementedException(); }</p>
<p>256:         }</p>
<p>257:</p>
<p>258:         public override int MinRequiredPasswordLength</p>
<p>259:         {</p>
<p>260:             get { throw new NotImplementedException(); }</p>
<p>261:         }</p>
<p>262:</p>
<p>263:         public override int PasswordAttemptWindow</p>
<p>264:         {</p>
<p>265:             get { throw new NotImplementedException(); }</p>
<p>266:         }</p>
<p>267:</p>
<p>268:         public override MembershipPasswordFormat PasswordFormat</p>
<p>269:         {</p>
<p>270:             get { throw new NotImplementedException(); }</p>
<p>271:         }</p>
<p>272:</p>
<p>273:         public override string PasswordStrengthRegularExpression</p>
<p>274:         {</p>
<p>275:             get { throw new NotImplementedException(); }</p>
<p>276:         }</p>
<p>277:</p>
<p>278:         public override bool RequiresQuestionAndAnswer</p>
<p>279:         {</p>
<p>280:             get { throw new NotImplementedException(); }</p>
<p>281:         }</p>
<p>282:</p>
<p>283:         public override bool RequiresUniqueEmail</p>
<p>284:         {</p>
<p>285:             get { throw new NotImplementedException(); }</p>
<p>286:         }</p>
<p>287:</p>
<p>288:         public override string ResetPassword(string username, string answer)</p>
<p>289:         {</p>
<p>290:             throw new NotImplementedException();</p>
<p>291:         }</p>
<p>292:</p>
<p>293:         public override bool UnlockUser(string userName)</p>
<p>294:         {</p>
<p>295:             throw new NotImplementedException();</p>
<p>296:         }</p>
<p>297:</p>
<p>298:         public override void UpdateUser(MembershipUser user)</p>
<p>299:         {</p>
<p>300:             throw new NotImplementedException();</p>
<p>301:         }</p>
<p>302:         #endregion</p>
<p>303:</p>
<p>304:     }</p>
<p>305: }<br />Now we have to do the same thing with the ShareDoveRolesProvider class &ndash; this is where we implement our roles logic &ndash; which user belongs to which internal role. Don&rsquo;t mix this up with SharePoint roles &ndash; they still exist, SharePoint still takes care of the authorization, but there might be a case where we want to know the internal roles of the source system. It means, we might want to know who of our jazz people play piano (they are in the &ldquo;pianist&rdquo; role), and the roles provider can give us this answer.</p>
<p>The following methods have to be implemented in the Roles provider:</p>
<p>public override string[] GetAllRoles()</p>
<p>public override string[] GetRolesForUser(string username)</p>
<p>public override string[] GetUsersInRole(string rolename)</p>
<p>public override bool IsUserInRole(string username, string rolename)</p>
<p>public override bool RoleExists(string rolename)</p>
<p>public override string[] FindUsersInRole(string rolename, string usernameToMatch)<br />And again, let&rsquo;s do some hard coding for this demo purposes. Here is how the class should look like:</p>
<p>1: using System;</p>
<p>2: using System.Collections.Generic;</p>
<p>3: using System.Linq;</p>
<p>4: using System.Text;</p>
<p>5: using System.Web.Security;</p>
<p>6:</p>
<p>7: namespace Progressive.ShareDove.DiverseTests.ShareDoveMembershipAndRolesProvider</p>
<p>8: {</p>
<p>9:     /// &lt;summary&gt;</p>
<p>10:     /// ShareDove Roles Provider</p>
<p>11:     /// &lt;/summary&gt;</p>
<p>12:     public class ShareDoveRolesProvider : RoleProvider</p>
<p>13:     {</p>
<p>14:</p>
<p>15:         public override string ApplicationName { get; set; }</p>
<p>16:</p>
<p>17:         /// &lt;summary&gt;</p>
<p>18:         /// All Roles</p>
<p>19:         /// &lt;/summary&gt;</p>
<p>20:         private string[] m_AllRoles = { "Drummer", "Pianist", "Saxophonist", "Trumpeter", "Clarinetist", "Singer", "Bandleader" };</p>
<p>21:         private string[,] m_RolesForUser = new string[,] {</p>
<p>22:             {"Ella Fitzgerald", "Vocalist"},</p>
<p>23:             {"Billie Holiday","Vocalist"},</p>
<p>24:             {"Louis Armstrong","Vocalist,Trumpeter"},</p>
<p>25:             {"Duke Ellington","Pianist,Bandleader"},</p>
<p>26:             {"Miles Davis",  "Trumpeter,Bandleader"},</p>
<p>27:             {"Fletcher Henderson","Pianist,Bandleader"},</p>
<p>28:             {"Benny Goodman","Clarinetist,Bandleader"},</p>
<p>29:             {"Jelly Roll Morton","Pianist,Bandleade"},</p>
<p>30:         };</p>
<p>31:</p>
<p>32:         /// &lt;summary&gt;</p>
<p>33:         /// Retrieve all available roles</p>
<p>34:         /// &lt;/summary&gt;</p>
<p>35:         /// &lt;returns&gt;String-array with all roles&lt;/returns&gt;</p>
<p>36:         public override string[] GetAllRoles()</p>
<p>37:         {</p>
<p>38:             return m_AllRoles;</p>
<p>39:         }</p>
<p>40:</p>
<p>41:         /// &lt;summary&gt;</p>
<p>42:         /// Get the array of roles for the specified user</p>
<p>43:         /// &lt;/summary&gt;</p>
<p>44:         /// &lt;param name="username"&gt;User name&lt;/param&gt;</p>
<p>45:         /// &lt;returns&gt;String-array with all roles for the specified user&lt;/returns&gt;</p>
<p>46:         public override string[] GetRolesForUser(string username)</p>
<p>47:         {</p>
<p>48:             List&lt;string&gt; users = new List&lt;string&gt;();</p>
<p>49:             for (int i = 0; i &lt;= m_RolesForUser.GetUpperBound(0); i++)</p>
<p>50:             {</p>
<p>51:                 if (m_RolesForUser[i, 0] == username)</p>
<p>52:                     users = m_RolesForUser[i, 1].Split(',').ToList&lt;string&gt;();</p>
<p>53:             }</p>
<p>54:</p>
<p>55:             return users.ToArray();</p>
<p>56:         }</p>
<p>57:</p>
<p>58:         /// &lt;summary&gt;</p>
<p>59:         /// Get all the users who are in the given role</p>
<p>60:         /// &lt;/summary&gt;</p>
<p>61:         /// &lt;param name="rolename"&gt;Role name&lt;/param&gt;</p>
<p>62:         /// &lt;returns&gt;String-array with all users being in the given role&lt;/returns&gt;</p>
<p>63:         public override string[] GetUsersInRole(string rolename)</p>
<p>64:         {</p>
<p>65:             List&lt;string&gt; users = new List&lt;string&gt;();</p>
<p>66:             for (int i = 0; i &lt;= m_RolesForUser.GetUpperBound(0); i++)</p>
<p>67:             {</p>
<p>68:                 List&lt;string&gt; userRoles = m_RolesForUser[i, 1].Split(',').ToList&lt;string&gt;();</p>
<p>69:                 if (userRoles.Where(userRole =&gt; userRole == rolename).Count() &gt; 0)</p>
<p>70:                 {</p>
<p>71:                     users.Add(m_RolesForUser[i, 0]);</p>
<p>72:                 }</p>
<p>73:             }</p>
<p>74:</p>
<p>75:             return users.ToArray();</p>
<p>76:</p>
<p>77:         }</p>
<p>78:</p>
<p>79:         /// &lt;summary&gt;</p>
<p>80:         /// Check if the user is in the role</p>
<p>81:         /// &lt;/summary&gt;</p>
<p>82:         /// &lt;param name="username"&gt;Username&lt;/param&gt;</p>
<p>83:         /// &lt;param name="rolename"&gt;Role name&lt;/param&gt;</p>
<p>84:         /// &lt;returns&gt;True if user is in the role&lt;/returns&gt;</p>
<p>85:         public override bool IsUserInRole(string username, string rolename)</p>
<p>86:         {</p>
<p>87:             List&lt;string&gt; usersForRole = GetUsersInRole(rolename).ToList();</p>
<p>88:</p>
<p>89:             if (usersForRole.Where(userName =&gt; userName == username).Count() &gt; 0)</p>
<p>90:             {</p>
<p>91:                 return true;</p>
<p>92:             }</p>
<p>93:             else</p>
<p>94:             {</p>
<p>95:                 return false;</p>
<p>96:             }</p>
<p>97:</p>
<p>98:         }</p>
<p>99:</p>
<p>100:         /// &lt;summary&gt;</p>
<p>101:         /// Check of the role with the given name exists</p>
<p>102:         /// &lt;/summary&gt;</p>
<p>103:         /// &lt;param name="rolename"&gt;Role name&lt;/param&gt;</p>
<p>104:         /// &lt;returns&gt;True if the role exists&lt;/returns&gt;</p>
<p>105:         public override bool RoleExists(string rolename)</p>
<p>106:         {</p>
<p>107:             bool roleExsists = m_AllRoles.ToList().Where(roleName =&gt; roleName == rolename).Count() &gt; 0;</p>
<p>108:</p>
<p>109:             return roleExsists;</p>
<p>110:         }</p>
<p>111:</p>
<p>112:         /// &lt;summary&gt;</p>
<p>113:         /// Search for users in the goven role</p>
<p>114:         /// &lt;/summary&gt;</p>
<p>115:         /// &lt;param name="rolename"&gt;Name of the role to search the users in&lt;/param&gt;</p>
<p>116:         /// &lt;param name="usernameToMatch"&gt;Pattern to search in the role&lt;/param&gt;</p>
<p>117:         /// &lt;returns&gt;All the users which mach the pattern&lt;/returns&gt;</p>
<p>118:         public override string[] FindUsersInRole(string rolename, string usernameToMatch)</p>
<p>119:         {</p>
<p>120:             List&lt;string&gt; users = GetUsersInRole(rolename).ToList&lt;string&gt;();</p>
<p>121:</p>
<p>122:             List&lt;string&gt; foundUsers = users.Where(userName =&gt; userName.ToLowerInvariant().Contains(usernameToMatch.ToLowerInvariant())).ToList&lt;string&gt;();</p>
<p>123:</p>
<p>124:             return foundUsers.ToArray();</p>
<p>125:</p>
<p>126:         }</p>
<p>127:</p>
<p>128:         #region Not implemented methods</p>
<p>129:         public override void AddUsersToRoles(string[] usernames, string[] roleNames)</p>
<p>130:         {</p>
<p>131:             throw new NotImplementedException();</p>
<p>132:         }</p>
<p>133:</p>
<p>134:         public override void CreateRole(string roleName)</p>
<p>135:         {</p>
<p>136:             throw new NotImplementedException();</p>
<p>137:         }</p>
<p>138:</p>
<p>139:         public override bool DeleteRole(string roleName, bool throwOnPopulatedRole)</p>
<p>140:         {</p>
<p>141:             throw new NotImplementedException();</p>
<p>142:         }</p>
<p>143:</p>
<p>144:</p>
<p>145:         public override void RemoveUsersFromRoles(string[] usernames, string[] roleNames)</p>
<p>146:         {</p>
<p>147:             throw new NotImplementedException();</p>
<p>148:         }</p>
<p>149:         #endregion</p>
<p>150:     }</p>
<p>151: }<br />So that&rsquo;s it, we have our custom ASP.NET membership and roles provider that is authenticating our jazz people. Finally, we have to do with it is to sign it, and to throw it to the GAC. Yes, it has to go there.</p>
<p>(gacutil -i ShareDove.MembershipAndRolesProvider.dll)</p>
<p>00-gac</p>
<p>Creating a Claims-based Web Application<br />The next step is to create a SharePoint Web Application which will used Claims-based authentication. As we said, the classical mode authentication is still the default mode, so we have to change it manually:</p>
<p>(click on the picture for the full size)</p>
<p>01-a-createwebapp</p>
<p>We see that we explicitly have to choose the &ldquo;Claims based authentication&rdquo;, and to select the &ldquo;Enable Forms Based Authentication (FBA)&rdquo; option.</p>
<p>We also see that we have to set the &ldquo;ASP.NET Membership Provider Name&rdquo; and &ldquo;ASP.NET Role Manager Name&rdquo;. At this point just give some names which make sense (these names will be later displayed to your users!), but write them down in the Notepad since we will be using it in the SharePoint-Voodoo session that is coming.</p>
<p>Voodoo time!<br />OK, now we have just created a SharePoint web application, and we told to the Web Application that we want to use a custom ASP.NET membership and role providers for our Form Based Authentication, and that they are called, for example, &ldquo;ShareDove Membership Provider&rdquo; and &ldquo;ShareDove Roles Provider&rdquo;.</p>
<p>Now, we have to associate somehow this canonical names with our class library which is waiting in GAC to be used. The most logical and straight-forward way is to do it in the web.config.</p>
<p>And since it is that logical, we have to do it three times. Three. The magical voodoo number.</p>
<p>This is not a joke. We have to register our assembly in the web.config of the newly created SharePoint web application (ok, that makes sense). Then in the SharePoint STS (Security Token Service &ndash; a SharePoint Service Application which is handling whole this claims thing). OK, somehow I can understand that as well. But then, we have to register it in the web.config of the Central Administration application as well. Voodoo. No other explanation for that.</p>
<p>iis1</p>
<p>iis2</p>
<p>iis3</p>
<p>(Applications where we have to edit the web.config)</p>
<p>Luckily, at all three web.config files we have to enter the same peace of code. Under the &lt;system.web&gt; section, we have to add our new providers in the &ldquo;membership&rdquo; and &ldquo;roleManager&rdquo; sections as following:</p>
<p>1: &lt;membership defaultProvider="i"&gt;</p>
<p>2:     &lt;providers&gt;</p>
<p>3:         &lt;add name="i" type="Microsoft.SharePoint.Administration.Claims.SPClaimsAuthMembershipProvider, Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" /&gt;</p>
<p>4:         &lt;add name="ShareDove Membership Provider" applicationName="ShareDove Membership" type="Progressive.ShareDove.DiverseTests.ShareDoveMembershipAndRolesProvider.ShareDoveMembershipProvider, ShareDove.MembershipAndRolesProvider, Version=1.0.0.0, Culture=neutral, PublicKeyToken=f1182222d75a911e"/&gt;</p>
<p>5:     &lt;/providers&gt;</p>
<p>6: &lt;/membership&gt;</p>
<p>7: &lt;roleManager defaultProvider="c" enabled="true" cacheRolesInCookie="false"&gt;</p>
<p>8:     &lt;providers&gt;</p>
<p>9:         &lt;add name="c" type="Microsoft.SharePoint.Administration.Claims.SPClaimsAuthRoleProvider, Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" /&gt;</p>
<p>10:         &lt;add name="ShareDove Role Provider" type="Progressive.ShareDove.DiverseTests.ShareDoveMembershipAndRolesProvider.ShareDoveRolesProvider, ShareDove.MembershipAndRolesProvider, Version=1.0.0.0, Culture=neutral, PublicKeyToken=f1182222d75a911e" applicationName="ShareDove Membership" /&gt;</p>
<p>11:     &lt;/providers&gt;</p>
<p>12: &lt;/roleManager&gt;</p>
<p>WARNING 1: Leave the existing providers alone, otherwise the SharePoint-Voodo-Gods will take revenge on you.</p>
<p>WARNING 2: Don&rsquo;t copy my assembly names and tokens &ndash; they won&rsquo;t work at your SharePoint.</p>
<p>WARNING 3: the &ldquo;name&rdquo; attribute of both providers have to be EXACTLY the same as entered when creating the web application.</p>
<p>Creating the Site Collection and testing the whole thing<br />Now we can create a SiteCollection on this application as we are used to.</p>
<p>sitecol</p>
<p>And, when we try to open our site collection, voila&hellip;</p>
<p>image_thumb_5_01744BD2</p>
<p>SharePoint asks us how we would like to log on!</p>
<p>Let&rsquo;s try the Forms Authentication, and let&rsquo;s try to sign in as a great jazz pianist Jelly Roll Morton:</p>
<p>image_thumb_7_01744BD2</p>
<p>04-signed-accessdenied</p>
<p>OK, it&rsquo;s obvious that good ol&rsquo; Jelly doesn&rsquo;t have any rights on our SharePoint portal yet! We did authenticate him (&ldquo;You are currently signed in as: jelly roll morton&rdquo;), but, authorization is still on the SharePoint part of the game. Poor Jelly can&rsquo;t do anything yet.</p>
<p>Let&rsquo;s sign out, and sign in again as Administrator (or some other Very Powerful User) using the Windows Authentication. Let&rsquo;s create a SharePoint Group called &ldquo;Jazzers&rdquo;, and fill it with some users:</p>
<p>07-picker-jazzers</p>
<p>OK, here is our new people picker! We see, on the left side, more groups, one of them being the &ldquo;Forms Auth&rdquo; &ndash; that is where we find our jazz people. Let&rsquo;s select them all in our &ldquo;Jazzers&rdquo; SharePoint group, and let&rsquo;s give some rights to that group:</p>
<p>09-give-permissions-group</p>
<p>When selecting the FBA users, if we click at the user information, we see the following:</p>
<p>08-member-info</p>
<p>User Information panel gives us all the information we provided through our ASP.NET membership provider, and it clearly states the provider which gave the info (&ldquo;ShareDove Membership Provider&rdquo;)</p>
<p>We can now log out as the Administrator, and try to log in as Billie Holiday using the FBA again:</p>
<p>10-logged-claims</p>
<p>So, we see, it really does work! Our external users can do exactly what we authorize them to do. Even open the Word documents!</p>
<p>Open-mouthed smile</p>
<p>Hope this helps someone.</p>
<p>Comments<br />0 comments</p>
<p>Tagged on: SharePoint<br />By Adis Jugo | 05.01.2011 | Development | 6 Comments |<br />&larr; Happy New Year!How to Become a SharePoint Admin? &rarr;<br />6 thoughts on &ldquo;Developing a Custom Membership Provider from the scratch, and using it in the FBA (Form Based Authentication) in SharePoint 2010&rdquo;<br />Pingback: Writing a Custom Membership Provider from the scratch and using it for FBA in SharePoint 2010 - Quark&rsquo;s bar</p>
<p>NADY(Egypt)<br />23.03.2011 at 16:41<br />Thank you soOooOOo Much &hellip;. i like your way</p>
<p>Log in to Reply</p>
<p>luis<br />11.04.2012 at 19:25<br />Voodoo</p>
<p>&ldquo;OK, somehow I can understand that as well. But then, we have to register it in the web.config of the Central Administration application as well. Voodoo. No other explanation for that.&rdquo;</p>
<p>just one reazon for now:</p>
<p>example: who do you set the administrator, if you want an administrator from the FBA provider? :)))</p>
<p>Log in to Reply</p>
<p>Kashif<br />31.05.2012 at 17:41<br />this post as well as many others only outline the steps. i have followed each instruction here and on other posts available on the net (which are almost exactly the same), however i do not get the user to show up when trying to add. further it would be nice to mention that Central Admin doens&rsquo;t have any membership/providers in the config file so simply adding my custom providers, it resulted in username/password to appear everytime i click on any of the links in CA and it wouldn&rsquo;t even validate the user that is actually logged in. removing membership/providers from CA config file stabilizes this. The question remains: why am i not able to add the user?</p>
<p>Log in to Reply</p>
<p>Arjun<br />21.06.2012 at 13:09<br />Unfortunately also followed all steps, but fails when users are to be added (none found). Too many possible causes of error to look into, but just thought to post to flag that all is not straightforward and well with this :(</p>
<p>Log in to Reply</p>
<p>Adis Jugo Post author<br />05.07.2012 at 12:27<br />Hi Arjun,</p>
<p>difficult to guess &ndash; you didnt&rsquo;t provide much of an info what went wrong &amp; possible error messages.</p>
<p>Log in to Reply<br />Leave a Reply<br />You must be logged in to post a comment.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g326eq.html">Screen Orientation for Windows Phone</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1p0l4q.html">MySQL int&lpar;11&rpar;及int&lpar;M&rpar;解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1p1pj9.html">戴文的Linux内核专题：10配置内核（6）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1nevg8.html">Binder相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k153pr9.html">基于PinnedSectionListView实现联系人通讯录并且点击打电话</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdej538.html">jasper3</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1dzyx9.html">Direct2D 几何计算和几何变幻</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdmxrk9.html">Codeforces Round &num;364 &lpar;Div&period; 2&rpar; C&period;They Are Everywhere</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ydg4r8.html">SVN下载分支、合并分支</a>
		</li>
						<li><a href="https://www.batexi.com/a/950z7n68.html">201521123028 《Java程序设计》第6周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjzwvr8.html">IDEA热部署（一）---解析关键配置。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjl4v38.html">springboot 入门七-静态资源处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojwemxq.html">python 常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16mxxq.html">修改vue  element  Transfer 穿梭框里内容区的宽度</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvj7px8.html">实验十一  团队作业7---团队项目设计完善&amp;amp&semi;编码测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r45x48.html">SetTimer  API函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1g2og9.html">&lbrack;T-ARA N4&sol;二段横踢&rsqb;&lbrack;Can We Love&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4k0pk9.html">php中memcached的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllyw26q.html">python科学计算模块NumPy</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp30r49.html">vue&period;js项目打包上线</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwjl0my8.html">MAC安装Securecrt破解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jk0rl8.html">schemes-universalLink-share&lowbar;IOS-android-WeChat-chunleiDemo</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgn1mr8.html">php强制下载文件并显示原始文件名</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpok459.html">&lbrack;Q&rsqb;无法卸载怎么办</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjnlnk8.html">C&num;第十二天</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpolk39.html">1&period;1 Eclipse下载安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj12yk9.html">NSLineBreakMode</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpo6o69.html">JS时间日期格式转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjlpyl8.html">fidder   https以及Fiddler抓取HTTPS协议</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzm7el8.html">《学习的艺术》 &lpar;The Art of Learning&rpar;&mdash;&mdash;划小圈 &lpar;Making Smaller Circles&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
